/*
 * Copyright (C) 2006 Dell Inc.
 * Chieng-Hwa Lin <chieng-hwa_lin@dell.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef __DCGPIO_H_INCLUDED__
#define __DCGPIO_H_INCLUDED__


#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(1)

spinlock_t    ControlLock_bhlock;
spinlock_t    ControlLock_irqlock;
wait_queue_head_t FanInterruptSemaphore;  // Sempahore for fan interrupt
wait_queue_head_t TempInterruptSemaphore;  // Sempahore for temperature interrupt
wait_queue_head_t ShftgInterruptSemaphore;  // Sempahore for shifty interrupt
wait_queue_head_t BladeInterruptSemaphore;  // Sempahore for blade interrupt
wait_queue_head_t IOMInterruptSemaphore;  // Sempahore for IOM interrupt
wait_queue_head_t ECCInterruptSemaphore;  // Sempahore for IOM interrupt
wait_queue_head_t XilinxRecoverySemaphore;  // Sempahore for PPC1 recovery
wait_queue_head_t PSUInterruptSemaphore;  // Sempahore for PSU interrupt
wait_queue_head_t CPInterruptSemaphore;  // Sempahore for CP interrupt
wait_queue_head_t KVMInterruptSemaphore;  // Sempahore for KVM interrupt
wait_queue_head_t recovery_thread_semaphore;  // Sempahore for recovery handling

// Prototypes

void gpio_spin_lock(PGPIO_DEVICE_EXTENSION pGpioCard);
void gpio_spin_unlock(PGPIO_DEVICE_EXTENSION pGpioCard);

//--------------------------------------------------------------------
// Functions Prototypes
//--------------------------------------------------------------------
void CMCGpioReadReg(int base_address, int offset, int *reg_result);
void CMCGpioWriteReg(int base_address, int offset, u16 reg_input);
void CMCGpioReadReg32(u32 base_address, u32 offset, u32 *reg_result);
void CMCGpioWriteReg32(int base_address, int offset, u32 reg_input);
void CMCGpioSetBits(int base_address, int offset, u16 mask, u16 val);
void CMCGpioClrBits(int base_address, int offset, u16 mask);
void CMCGpioSetBits32(int base_address, int offset, u32 mask, u32 val);
void CMCGpioClrBits32(int base_address, int offset, u32 mask);

// deprecated functions
#define CMCGpioReadReg32Unmapped CMCGpioReadReg32
#define CMCGpioWriteReg32Unmapped CMCGpioWriteReg32


#pragma pack()

#ifdef __cplusplus
}
#endif


#endif // __DCGPIO_H_INCLUDED__

