/* 
    CMC RPC Client library
    Copyright (C) 2010 Dell, Inc

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include <string.h>
#include <stdlib.h> 
#include <stdio.h>
#include "cmcrpc-c.h"

static void test_ssn_entry_list();
static void test_ssn_close();
static void test_ssn_log();
static void test_ssn_modes();

int main(int argc, char *argv[])
{
    CMCGetLocalCMCState_rpc();
    return 0;
}

static void 
test_ssn_modes()
{
    printf("password mode = %i\n", ssn_is_password_mode_rpc());
    printf("vendor mode = %i\n", ssn_is_vendor_mode_rpc());
}

static void 
test_ssn_entry_list()
{
    int sidlist[24];
    unsigned int numfound;
    unsigned int i;

    ssn_entry_list_rpc(0, NULL, NULL, sidlist, &numfound);

    for(i=0; i<numfound; i++) {
        fprintf(stdout, "%i\n", sidlist[i]);
    }
}

static void 
test_ssn_close()
{
    ssn_close_rpc(1234);
}

static void 
test_ssn_log()
{
    ssn_log_rpc(1, "test");
}
